// SplashLib.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

static AFX_EXTENSION_MODULE SplashLibDLL = { NULL, NULL };

class DllInstanceSwitcher
{
public:
	DllInstanceSwitcher()
	{
		m_hInst = AfxGetResourceHandle();
		AfxSetResourceHandle(SplashLibDLL.hResource);
	}
	~DllInstanceSwitcher()
	{
		AfxSetResourceHandle(m_hInst);
	}
private:
	HINSTANCE m_hInst;
};

#define SWITCH_RESOURCE  DllInstanceSwitcher __SwitchInstance;




extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("SplashLib.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(SplashLibDLL, hInstance))
			return 0;

		new CDynLinkLibrary(SplashLibDLL);

	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("SplashLib.DLL Terminating!\n");

		// Terminate the library before destructors are called
		AfxTermExtensionModule(SplashLibDLL);
	}
	return 1;   // ok
}

#include "SplashClass.h"

static CSplashClass* global_Splash = NULL;
extern "C" AFX_EXT_API void StartSplash()
{
	SWITCH_RESOURCE
	if (global_Splash!=NULL)
		return;
	global_Splash = new CSplashClass;
}


extern "C" AFX_EXT_API void EndSplash(HWND wnd)
{
	if (global_Splash==NULL)
		return;
	if (wnd)
	{
		SetFocus(wnd);
		SetForegroundWindow(wnd);
	}
	delete global_Splash;
}


